#!/bin/sh

cd /home/user/imagemagick/


# This is the weather URL.  Change this to your URL
WEATHERURL="http://thefuckingweather.com/?where=rochester+ny"

#unit used above.  If C, use the other.
UNIT="F"
#UNIT="C"

# Current temperature must be above this to use "summer" theme
USESUMMER=55
PNGSUMMER="summer.jpg"
#USESUMMER=28

# Current temperature must be below this to use "winter" theme
USEWINTER=35
PNGWINTER="winter.jpg"
#USEWINTER=3

#PNG to use for other theme (not summer or winter)
PNGOTHER="space.jpg"


# How often we update if NOT on wifi (6 hours)
# Set this to 0 if you want it to ignore if on wifi vs 2/3G
CHECKINT=21600

######## You shouldn't need to change anything below here ###############

# Name of our temporary file from Yahoo
TEMPNAME="ywtemp.htm"
TEXTNAME="ywtemp.txt"
TEMPPNG="ywtemp.png"
OUTPUTPNG="lockslider.png"

if [ ! $CHECKINT -eq 0  ] && [ -e $TEMPNAME ]
then

#seet if we have a wifi connection
wifion=`/sbin/ifconfig wlan0 | grep -i "inet addr" | wc -l`

# if not on wifi and we have a previous file, check it to see
# if we want to update again this soon while on 2G/3G data.
if [ ! $wifion -eq 1  ]
then
    # check time stamp on the existing temp file
    cur_timestamp=`date +%s`
    my_stat=`stat -t $TEMPNAME 2>/dev/null`
    read name size blocks unk uid gid dev inode links unk2 unk3 last_access last_mod last_change ioblock << ENDHERE
    $(echo $my_stat)
ENDHERE

    #Compare that stamp to the current time
    if [ $last_mod ]
    then
        time_diff=`expr $cur_timestamp - $last_mod`
        if [ $time_diff -lt $CHECKINT ]
        then    
	    # We updated recently enough and are not on wifi
	    # Tell QBW (or caller) we left without update.
	    exit 1
        fi
    fi  
fi
fi

# We are updating!  Getting all the necessary info.
# That's where you should change url to your yahoo weather web page.
#wget --user-agent="" -q -t 1 -T 10 -O "$TEMPNAME" "$WEATHERURL" || exit 2
#lynx -source "$WEATHERURL" >  "$TEMPNAME" || exit 2

python parsepage.py "$TEMPNAME" > "$TEXTNAME"

# Thats where we get the image associated with the weather.
#wget --user-agent="" -q -t 1 -T 10 -O $TEMPPNG `grep -i icon "$TEXTNAME"|head -1|cut -d: -f2-` 

#Get all of out temperatures into variables
CurTemp=`grep -i current: "$TEXTNAME" | cut -d: -f2 | grep -o '[-0-9][-0-9]*'`
HighTemp=`grep -i highs: "$TEXTNAME" | cut -d: -f2 | grep -o '[-0-9][-0-9]*'`
LowTemp=`grep -i lows: "$TEXTNAME" | cut -d: -f2 | grep -o '[-0-9][-0-9]*'`
ForeNum=`grep -i forcasts: "$TEXTNAME" | cut -d: -f2 | grep -o '[-0-9][-0-9]*'`

FiveFore=`tail -$ForeNum "$TEXTNAME" `

CurDate=`date `

# Summer scenario.
if [ $CurTemp -gt  $USESUMMER ]
then 
#echo "Using Summer theme"
convert $PNGSUMMER \
-page +600+15 -background transparent -fill grey -pointsize 12 -strokewidth 1  -stroke grey  label:"$CurDate" \
-page +550+60 -background transparent -fill white -font fonts/2toon2v2.ttf -pointsize 140 -strokewidth 2  -stroke black  label:"$CurTemp$UNIT" \
-page +350+345 -background transparent -fill orange -font fonts/2toon2v2.ttf -pointsize 90 -strokewidth 2  -stroke black  label:"$HighTemp$UNIT" \
-page +26+345 -background transparent -fill "#2df2a879ffff" -font fonts/2toon2v2.ttf -pointsize 90 -strokewidth 2  -stroke black  label:"$LowTemp$UNIT" \
-page +520+180 -background transparent -fill "#2df2a879ffff" -font fonts/tahoma.ttf -pointsize 25 -strokewidth 2  -stroke black  label:"$FiveFore" \
-flatten -draw "image over 30,20 425,300 $TEMPPNG" $OUTPUTPNG 

# Winter scenario.
else
if [ $CurTemp -lt  $USEWINTER ]
then
#echo "Using Winter theme"
convert $PNGWINTER \
-page +600+15 -background transparent -fill grey -pointsize 12 -strokewidth 1  -stroke grey  label:"$CurDate" \
-page +550+60 -background transparent -fill white -font fonts/2toon2v2.ttf -pointsize 140 -strokewidth 2  -stroke black  label:"$CurTemp$UNIT" \
-page +350+345 -background transparent -fill orange -font fonts/2toon2v2.ttf -pointsize 90 -strokewidth 2  -stroke black  label:"$HighTemp$UNIT" \
-page +26+345 -background transparent -fill "#2df2a879ffff" -font fonts/2toon2v2.ttf -pointsize 90 -strokewidth 2  -stroke black  label:"$LowTemp$UNIT" \
-page +520+180 -background transparent -fill "#2df2a879ffff" -font fonts/tahoma.ttf -pointsize 25 -strokewidth 2  -stroke black  label:"$FiveFore" \
-flatten -draw "image over 30,20 425,300 $TEMPPNG" $OUTPUTPNG 

# not summer or winter scenario.
else
#echo "Using Space theme"
convert $PNGOTHER \
-page +600+15 -background transparent -fill grey -pointsize 12 -strokewidth 1  -stroke grey  label:"$CurDate" \
-page +550+60 -background transparent -fill white -font fonts/2toon2v2.ttf -pointsize 140 -strokewidth 2  -stroke black  label:"$CurTemp$UNIT" \
-page +350+345 -background transparent -fill orange -font fonts/2toon2v2.ttf -pointsize 90 -strokewidth 2  -stroke black  label:"$HighTemp$UNIT" \
-page +26+345 -background transparent -fill "#2df2a879ffff" -font fonts/2toon2v2.ttf -pointsize 90 -strokewidth 2  -stroke black  label:"$LowTemp$UNIT" \
-page +520+180 -background transparent -fill "#fdf2a879ffff" -font fonts/tahoma.ttf -pointsize 25 -strokewidth 2  -stroke white  label:"$FiveFore" \
-flatten -draw "image over 30,20 425,300 $TEMPPNG" $OUTPUTPNG 

fi
fi

# Making new slider.
cp slider.png /etc/hildon/theme/images/LockSliderThumbPortrait.png
cp slider.png /etc/hildon/theme/images/LockSliderThumb.png
# making other stuff disappear.
cp LockSliderTop.png /etc/hildon/theme/images/LockSliderTop.png
cp LockSliderRight.png  /etc/hildon/theme/images/LockSliderRight.png
cp LockSliderLeft.png /etc/hildon/theme/images/LockSliderLeft.png
cp LockSliderBottom.png /etc/hildon/theme/images/LockSliderBottom.png
# Moving the final background to your current theme directory.
sudo /bin/cp $OUTPUTPNG /etc/hildon/theme/backgrounds/lockslider.png

exit 0
